
//gcc -I/usr/include/glib-2.0 -I/usr/lib64/glib-2.0/include -lglib-2.0 -o ghashtable ghashtable.c

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

/** This prints out a key/value combination, for use in "g_hash_foreach".
**/
void printKeyValue( gpointer key, gpointer value, gpointer userData ) {
int realKey = GPOINTER_TO_INT( key );
char* realValue = (char*)value;
printf( "%d => %s\n", realKey, realValue );
return;
}

/** The main function.
**/
int main( int argc, char** argv ) {
//assign pointer to GHashTable
GHashTable* map = NULL;
//a pointer to value for data.
char* value = NULL;
GHashTableIter iter;
gpointer mykey, myvalue;

// Create the GHashTable.
map = g_hash_table_new_full(
g_direct_hash, g_direct_equal, //< This is an integer hash.
NULL, //< There is nothing to free for our key.
free //< Call "free" on the value (made with "strdup").
);

// Insert some values.
/*
2. sin
3. sinphase
4. rsplinesin
5. rsplinecos
6. rsplinecosphase
7. rsplinesinphase
8. gaussian
9. gaussianenvel
10. rsplinenoise
11. normalize
12. sawtoothsin
13. sawtoothcos
* */

// 2 => sin
value = strdup( "sin" );
g_hash_table_insert( map, GINT_TO_POINTER( 2 ), value );

// 3 => sinphase
value = strdup( "sinphase" );
g_hash_table_insert( map, GINT_TO_POINTER( 3 ), value );

// 4 => rsplinesin
value = strdup( "rsplinesin" );
g_hash_table_insert( map, GINT_TO_POINTER( 4 ), value );

// 5 => rsplinecos
value = strdup( "rsplinecos" );
g_hash_table_insert( map, GINT_TO_POINTER( 5 ), value );

// 6 => rsplinecosphase
value = strdup( "rsplinecosphase" );
g_hash_table_insert( map, GINT_TO_POINTER( 6 ), value );

// 7 => rsplinesinphase
value = strdup( "rsplinesinphase" );
g_hash_table_insert( map, GINT_TO_POINTER( 7 ), value );

// 8 => gaussian
value = strdup( "gaussian" );
g_hash_table_insert( map, GINT_TO_POINTER( 8 ), value );

// 9 => gaussianenvel
value = strdup( "gaussianenvel" );
g_hash_table_insert( map, GINT_TO_POINTER( 9), value );

// 10 => rsplinenoise
value = strdup( "rsplinenoise" );
g_hash_table_insert( map, GINT_TO_POINTER( 10 ), value );

// 11 => normalize
value = strdup( "normalize" );
g_hash_table_insert( map, GINT_TO_POINTER(11 ), value );

// 12 => sawtoothsin
value = strdup( "sawtoothsin" );
g_hash_table_insert( map, GINT_TO_POINTER( 12 ), value );

// 13 => sawtoothcos
value = strdup( "sawtoothcos" );
g_hash_table_insert( map, GINT_TO_POINTER( 13 ), value );

// Print out the contents of the map.
g_hash_table_foreach( map, printKeyValue, NULL );

printf( "-----\n");

//tests printing again, using printf and an iterator
g_hash_table_iter_init (&iter, map);              
while (g_hash_table_iter_next (&iter, &mykey, &myvalue))
{
printf( "%d => %s\n", mykey, myvalue );
}                   

// Destroy the hashtable.
g_hash_table_destroy( map );
map = NULL;

return 0;
}


/* REFERENCES
* printKeyValue, and g_direct_hash, strdup concepts:
* http://blog.sensecodons.com/2012/01/glib-ghashtable-and-gdirecthash.html
*/

//jhearon, 2016
