

//gcc -I/usr/include/glib-2.0 -I/usr/lib64/glib-2.0/include -lglib-2.0 -o mybtree mybtree.c


#include <stdio.h>
#include <string.h>
#include <glib.h>

/*
* CompareNames
*
* Compare function used so sort the tree
*/
gint CompareNames (gconstpointer item1, gconstpointer item2)
{
return *(int*)item1 - *(int*)item2;
}

/* Manually insert elements into balanced btree */
gboolean balanced_btree_insert(GTree* tree, int key, int value){
int * j  =(int *)malloc(sizeof(int));
*j = key;

int * k  =(int *)malloc(sizeof(int));
*k = value;

//checking if element already exists
if(!(g_tree_lookup(tree, (gpointer)j))){
g_tree_insert(tree, (gpointer)j, (gpointer)k);

return TRUE;
}
else return FALSE;
}

/*
* TraverseTree
*
* Function that displays the information at the
* node.
*/
gint TraverseTree (gpointer key, gpointer value, gpointer data)
{
int	* j = key;
int * k = value;

g_print ("Key: %d  Value: %d\n", *j, *k);
return FALSE;
}

/*
* main
*
* Program begins here.
*/
int main (int argc, char *argv[])
{

GTree	*tree;

tree = g_tree_new (CompareNames);

balanced_btree_insert (tree, 1, 1);
balanced_btree_insert (tree, 6, 26);
balanced_btree_insert (tree, 7, 2);
balanced_btree_insert (tree, 9, 36);
balanced_btree_insert (tree, 11, 100);
balanced_btree_insert (tree, 10, 40);
balanced_btree_insert (tree, 14, 50);

g_print ("Tree height: %d\n", g_tree_height (tree));
g_print ("Tree nodes: %d\n", g_tree_nnodes (tree));

g_print ("Tree:\n ");

g_tree_foreach (tree, TraverseTree, NULL);

//Look up a value, given a key
int * key  =(int *)malloc(sizeof(int));
*key = 6;
int * value  =(int *)malloc(sizeof(int));

value = (gintptr) g_tree_lookup (tree, key);
if (!value)  
{  
g_print("%d not found in tree.\n", *key);  
} else {  
g_print("Looking up key: %d; found-value: %d\n", *key, *value);  
} 

//free memory
g_tree_destroy(tree);
}

/* REFERENCES
*  GLib source code:
*  glib-master/glib/tests/tree.c
*  
*  https://www.ibm.com/developerworks/linux/tutorials/l-glib/
* 
*/

//jhearon, 2016
