
//gcc -I/usr/include/glib-2.0 -I/usr/lib64/glib-2.0/include -lglib-2.0 -o gseq gseq.c


#include <stdio.h>
#include <glib.h>
#include <stdlib.h>

GSequence *seq;
GSequenceIter *begin, *end, *mid;

static void simple_item(gpointer a)          
{
GSequenceIter *myiter = g_sequence_get_iter_at_pos(seq, GPOINTER_TO_INT(a));
printf(" %d ", GPOINTER_TO_INT(g_sequence_get(myiter))); 
}

gint static simple_int(gpointer a)          
{
GSequenceIter *myiter = g_sequence_get_iter_at_pos(seq, GPOINTER_TO_INT(a));
return(GPOINTER_TO_INT(g_sequence_get(myiter))); 
}

int main(int argc, char** argv) {
//const gchar * glib_check_version ();
int i;

//create a sequence
seq = g_sequence_new (NULL);

//load a sequence
for (i = 0; i < 24; i++) {
g_sequence_append (seq, GINT_TO_POINTER(i));
}       

printf("\n***sequence length: %d *** ", g_sequence_get_length(seq)); 

//list elements of the sequence
printf("\n***partial listing of the sequence: *** \n");
begin = g_sequence_get_iter_at_pos(seq, 5);
//only need to declare 'end' once unless it changes
end = g_sequence_get_end_iter(seq);
for (; begin != end; begin = g_sequence_iter_next(begin)) {
/* iterate the queue */
printf(" %d  ",  GPOINTER_TO_INT(g_sequence_get(begin)));
}

//!!!! need to reset start position for any subsequent 'for' loop
//ex. begin = g_sequence_get_begin_iter(seq);

printf("\n***From the midpoint of the sequence: *** \n");
begin = g_sequence_get_begin_iter(seq);	
mid = g_sequence_range_get_midpoint(begin, end);
for (; mid != end; mid = g_sequence_iter_next(mid)) {
/* iterate the queue */
printf(" %d  ",  GPOINTER_TO_INT(g_sequence_get(mid)));
}

printf("\n***all items in the sequence: *** \n");

begin = g_sequence_get_begin_iter(seq);
//begin = g_sequence_iter_next(begin); //can advance the sequence here
for (; begin != end; begin = g_sequence_iter_next(begin)) {
/* iterate the queue */
printf(" %d  ",  GPOINTER_TO_INT(g_sequence_get(begin)));
}
printf("\n");

printf("\n***list simple items from the sequence: *** \n");

for (int j = 1; j<24; j++){
simple_item(GINT_TO_POINTER(j));
}

printf("\n*** get a simple item from the sequence: *** \n");
printf(" %d ", simple_int(GINT_TO_POINTER(9)));

printf("\n");

g_sequence_free(seq);
return 0;
}


/* REFERENCES
*  
* //https://sourcecodebrowser.com/glib2.0/2.27.3/gsequence_8h.html
*/

//jhearon, 2016
