
//gcc -I/usr/include/glib-2.0 -I/usr/lib64/glib-2.0/include -lglib-2.0 -o ghash_slist ghash_slist.c


/* Using singly linked lists as the value for a hash table
* which employs keys with characteristic names of musical items:
* ex. short, long, chords.  Each list has 5 unique integers
* which trigger instrument numbers with short, and long sounds
* also chords.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <glib.h>
#include <glib/gprintf.h>

GSList *short_list = NULL;
GSList *long_list = NULL;
GSList *chord_list = NULL;

void add_element(GHashTable* hashtable, GSList *list, gchar * key, gpointer data) {  
list = g_hash_table_lookup(hashtable, key);
list = g_slist_append(list, data);
g_hash_table_insert(hashtable, key, list);
}

void output_content(GHashTable* hashtable, gchar * key) {
GSList * list = g_hash_table_lookup(hashtable, key);
guint length = g_slist_length(list); 
g_printf("length of %s is: %d\n", key, length);

while (list != NULL)
{
printf("List data: %d\n", list->data);
list = g_slist_next(list);
}
}

/** The main function.
**/
int main( int argc, char** argv ) {

//! This is the pointer to our hashtable's value data.
int i;
char c;

GHashTable* map = NULL;

gchar *list1 = NULL;
list1 = "shortlist";
gchar *list2 = NULL;
list2 = "longlist";
gchar *list3 = NULL;
list3 = "chordlist";
gpointer mykey, mydata;

//create a new hashtable
map = g_hash_table_new(NULL, NULL);

//load the into the slists
for (i = 2; i < 6; i++) {
add_element(map, short_list, list1, GINT_TO_POINTER (i));
}

for (i = 6; i < 10; i++) {
add_element(map, long_list, list2, GINT_TO_POINTER (i));
}

for (i = 10; i < 14; i++) {
add_element(map, chord_list, list3, GINT_TO_POINTER (i));
}

//****************************************
//********  User Switch to Choose another list *****
//****************************************
userswitch:
printf("\n");
printf("\nlist (s)hortdurs, (l)ongdurs, (c)hords or (q)uit: ");
//fflush(stdout); 
scanf("%c", &c);
while (getchar()!='\n'); 
switch(c)
{
case 's':
mykey = list1;
goto first;
case 'l':
mykey = list2;
goto first;
case 'c':
mykey = list3;
goto first;
case 'q':
goto last;
break;
default:
break;
} //ends switch
printf("\n");

first:
next:;  //empty statement ';' here to avoid label error

//DEBUG
//output_content(map, mykey);  

//print the selected list
GSList * list = g_hash_table_lookup(map, mykey);
guint length = g_slist_length(list); // 
g_printf("length of %s is: %d\n", mykey, length);

while (list != NULL)
{
printf("List data: %d\n", list->data);
list = g_slist_next(list);
}

goto userswitch;

last:
printf("\nbye\n");
//clear memory allocations
g_hash_table_destroy( map );
map = NULL;
g_slist_free(short_list);
g_slist_free(long_list);
g_slist_free(chord_list);
return 0;
}

/* REFERENCES
*  
* //http://blog.sensecodons.com/2012/01/glib-ghashtable-and-gdirecthash.html
* //http://gsk.sourceforge.net/gsk-reference/gsk-gskghelpers.html
*/

