;jhearon, 2016

<CsoundSynthesizer>
<CsOptions>
;csound  -s -d -+rtaudio=ALSA -odevaudio -b1024 -B16384  
;csound  -s -d -+rtaudio=ALSA -o/opt/snd-16/jstest.wav -b1024 -B16384  
</CsOptions>
<CsInstruments>

sr = 44100
;kr = 1
kr = 5
nchnls = 2
0dbfs  = 1

chn_k "inst", 1

ginum init 1024;
gkArr[] init ginum ;global array for amp scaling

gitable5 ftgen 500, 0, ginum, 8, 0, ginum, 0 ;empty table allocation for piecewise cubic spline curves
gitable6 ftgen 600, 0, ginum, 8, 0, ginum, 0
gitable7 ftgen 700, 0, ginum, 8, 0, ginum, 0
gitable8 ftgen 800, 0, ginum, 8, 0, ginum, 0
gitable9 ftgen 900, 0, ginum, 8, 0, ginum, 0

gitable10 ftgen 1000, 0, ginum, 21, 6  ;for wave shaping and normalizing
gitable11 ftgen 1100, 0, ginum, 4, 1000, 0 ;for wave shaping and normalizing

gitable12 ftgen 1200, 0, ginum, 8, 0, ginum, 0
gitable13 ftgen 1300, 0, ginum, 7, 0, ginum, 0 ;constructs segments from straight lines
gitable14 ftgen 1400, 0, ginum, 7, 0, ginum, 0

gitable20 ftgen 2000, 0, ginum, 7, 0, ginum, 0 ;a main, reusable table 

//   //////SCHEDULE an instrument//////
instr 1
  ;schedwhen p4, p5, 0, 1

k1 chnget "inst"
	printk2 k1
  schedwhen k1, k1, 0, 1
 ;schedwhen k1, k1, 0, 2 ; 2 is dur

endin

///////////////////////////////////////////////////////
///////////////////////////////////////////////////////
//              Short Sounds                         //
///////////////////////////////////////////////////////
///////////////////////////////////////////////////////
instr   2 ;Short_Sound: gaussian distribution and waveshaping w/envelope control.  Uses arate table normalizing.
  prints "***inst 9***\n";
seed 0;
ihertz random 400, 2000;
ipkamp = 0.75
iwsfn  = 1000  ;waveshaping function	
inmfn  = 1100  ;normalization function 	
							
agate expseg 0.9, p3* 0.10, 1.0, p3 * .90, 0.0001 ;overall amp envelope
actrl   linen  	.2, .5, p3 * .80, 1    ;waveshaping index control
aindex  poscil  actrl * 4, ihertz, 400	;sine wave to be distorted
asignal tablei  .5 + aindex, iwsfn, 1, 1 ;waveshaping (access table values by direct indexing)
anormal tablei  1/actrl, inmfn , 1, 1  ;amplitude normalization
        outs    asignal*anormal*ipkamp*agate, asignal*anormal*ipkamp*agate         
endin


//  //////Short_Sound:RSPLINE MOD by SIN w/phase to table including random noise//////
          ;includes final output envelope
instr 3
  prints "***inst 10***\n";
krangeMin init 2
krangeMax init 20
kcpsmin init 1
kcpsmax init 3
ksig init 0
seed 0;
iphase random 0.01, 0.99
ifreq random 400, 2000;
kcntr init 0
kval init 0
itwopi=3.14

reset:
ksp  rspline krangeMin, krangeMax, kcpsmin, kcpsmax  ;generate random spline
kval = sin(itwopi*(kcntr + (ginum * iphase))/(ginum/2)) 
krandom random 400, 2000
ksig = (ksp + kval) + (kval + krandom) ;modulation
tablew ksig, kcntr, 2000, 0, 0, 2  ;write sig moved by phase and added to sin to table
kcntr = kcntr + 1
if kcntr < ginum kgoto reset

;-----scale amp using array-------------
copyf2array gkArr, 2000
;copy from table to array
scalearray gkArr, -1, 1
copya2ftab gkArr, 1200  ;copy from array to table
tablegpw 1200 ;write the table quardpoint
;---------------------------------------
amp expseg 0.9, p3* 0.08, 1.0, p3 * .92, 0.0001 ;overall amp envelope
aout oscili 0.5, ifreq, 1200
		outs aout * amp, aout * amp
endin


//   //////Short_Sound:RSPLINE MOD by SIN w/phase to table//////
instr 4
  prints "***inst 4***\n";
krangeMin init 2
krangeMax init 20
kcpsmin init 2
kcpsmax init 3
seed 0;
ifreq random 400, 2000;
iphase random 0.01, 0.99

ksig init 0
kcntr init 0
itwopi=3.14

reset:
ksp  rspline krangeMin, krangeMax, kcpsmin, kcpsmax  ;generate random spline
ksin = sin(itwopi*(kcntr + (ginum * iphase))/(ginum/2)) 
ksig = ksp * ksin  ;simple modulation
tablew ksig, kcntr, 2000, 0, 0, 2  ;write spline modulated by sin to table
kcntr = kcntr + 1
if kcntr < ginum kgoto reset

;-----scale amp using array-------------
copyf2array gkArr, 2000 ;copy from table to array
scalearray gkArr, -1, 1
copya2ftab gkArr, 600  ;copy from array to table
tablegpw 600;write the table quardpoint
;---------------------------------------

amp expseg 0.9, p3* 0.08, 1.0, p3 * .92, 0.0001 ;overall amp envelope
aout oscili 0.5, ifreq, 600
	outs aout * amp, aout * amp

endin


//  //////Short_Sound:RSPLINE MOD by COS w/phase to table//////
instr 5
  prints "***inst 6***\n";
krangeMin init 5
krangeMax init 25
kcpsmin init 1
kcpsmax init 3
ksig init 0
seed 0;
iphase random 0.01, 0.99
ifreq random 400, 3000;
kcntr init 0
kval init 0
itwopi=3.14

reset:
ksp  rspline krangeMin, krangeMax, kcpsmin, kcpsmax  ;generate random spline
kval = cos(itwopi*(kcntr + (ginum * iphase))/(ginum/2)) 
ksig = ksp ^ kval ;modulation
tablew ksig, kcntr, 2000, 0, 0, 2  ;write sig moved by phase and added to sin to table
kcntr = kcntr + 1
if kcntr < ginum kgoto reset
;-----scale amp using array-------------
copyf2array gkArr, 2000 ;copy from table to array
scalearray gkArr, -1, 1
copya2ftab gkArr, 800  ;copy from array to table
tablegpw 800 ;write the table quardpoint
;---------------------------------------
amp expseg 0.9, p3* 0.10, 1.0, p3 * .90, 0.0001 ;overall amp envelope
aout oscili 0.5, ifreq, 800
	outs aout * amp, aout * amp
endin


///////////////////////////////////////////////////////
///////////////////////////////////////////////////////
//              Long Sounds                          //
///////////////////////////////////////////////////////
///////////////////////////////////////////////////////

//  //////Long_Sound:RSPLINE MOD by COS w/phase to table//////
instr 6
  prints "***inst 5***\n";
krangeMin init 5
krangeMax init 25
kcpsmin init 2
kcpsmax init 5
ksig init 0
seed 0;
iphase random 0.01, 0.99
ifreq random 400, 2000;
kcntr init 0
kval init 0
itwopi=3.14

reset:
ksp  rspline krangeMin, krangeMax, kcpsmin, kcpsmax  ;generate random spline
kval = cos(itwopi*(kcntr + (ginum * iphase))/(ginum/2)) 
ksig = ksp + kval ;modulation
tablew ksig, kcntr, 2000, 0, 0, 2  ;write sig moved by phase and added to sin to table
kcntr = kcntr + 1
if kcntr < ginum kgoto reset
;-----scale amp using array-------------
copyf2array gkArr, 2000 ;copy from table to array
scalearray gkArr, -1, 1
copya2ftab gkArr, 700  ;copy from array to table
tablegpw 700 ;write the table quardpoint
;---------------------------------------
aout oscili 0.5, ifreq, 700
	outs aout, aout
endin


//  //////Long_Sound:RSPLINE MOD by SIN w/phase to table including random noise//////
instr 7
  prints "***inst 7***\n";
krangeMin init 2
krangeMax init 20
kcpsmin init 1
kcpsmax init 3
ksig init 0
seed 0;
iphase random 0.01, 0.99
ifreq random 400, 2000;
kcntr init 0
kval init 0
itwopi=3.14

reset:
ksp  rspline krangeMin, krangeMax, kcpsmin, kcpsmax  ;generate random spline
kval = sin(itwopi*(kcntr + (ginum * iphase))/(ginum/2)) 
krandom random 400, 2000
ksig = (ksp + kval) + (kval + krandom) ;modulation
tablew ksig, kcntr, 2000, 0, 0, 2  ;write sig moved by phase and added to sin to table
kcntr = kcntr + 1
if kcntr < ginum kgoto reset

;-----scale amp using array-------------
copyf2array gkArr, 2000
;copy from table to array
scalearray gkArr, -1, 1
copya2ftab gkArr, 900  ;copy from array to table
tablegpw 900 ;write the table quardpoint
;---------------------------------------

aout oscili 0.5, ifreq, 900
		outs aout, aout
endin


instr   8 ;Long_Sound:gaussian distribution and waveshaping. Uses arate table normalizing.
  prints "***inst 8***\n";
seed 0;
ihertz random 400, 2000;
ipkamp = 0.5
iwsfn  = 1000  ;waveshaping function	
inmfn  = 1100  ;normalization function 	
							
agate   linen   1, .01, p3, .1  ;overall amp envelope
actrl   linen  	.9, 2, p3, 2    ;waveshaping index control
aindex  poscil  actrl, ihertz, 400	;sine wave to be distorted
asignal tablei  .5 + aindex, iwsfn, 1, 1 ;waveshaping (access table values by direct indexing)
anormal tablei  1/actrl, inmfn , 1, 1  ;amplitude normalization
        outs    asignal*anormal*ipkamp*agate, asignal*anormal*ipkamp*agate         
endin

//  //////Long_Sound:MYSAWTOOTH w/phase and waveshaping w/ cos and spline //////

instr 9
  prints "***inst 13***\n";
krangeMin init 2
krangeMax init 10
kcpsmin init 2
kcpsmax init 4
kval init 0
ksig init 0
kcos init 0
seed 0; 
iphase1 random 0.01, 0.99
iphase2 random 0.01, 0.99
ifreq random 400, 2000;
kcntr init 0
itwopi=3.14

reset:
ksp  rspline krangeMin, krangeMax, kcpsmin, kcpsmax  ;generate random spline
kcos = cos(itwopi*(kcntr + (ginum * iphase1))/(ginum/2)) 
;triangle
;kval  = (2 * (kcntr/ginum) - (floor((kcntr/ginum) + 0.5))); no phase **** amp is 0 to 1
kval  = (2 * ((kcntr + (ginum * iphase2))/(ginum) - ((floor(((kcntr + (ginum * iphase2))/(ginum)) + 0.5))))); amp -1 to 1
ksig = ksp *  (kcos + kval)  ;modulation
tablew ksig, kcntr, 2000, 0, 0, 2  ;write spline and triangle to table
kcntr = kcntr + 1
if kcntr < ginum kgoto reset

;-----scale amp using array-------------
copyf2array gkArr, 2000
;copy from table to array
scalearray gkArr, -1, 1
copya2ftab gkArr, 1400  ;copy from array to table
tablegpw 1400 ;write the table quardpoint
;---------------------------------------
;amp expseg 0.9, p3* 0.08, 1.0, p3 * .92, 0.0001 ;overall amp envelope
aout oscili 0.5, ifreq, 1400
		;outs aout * amp, aout * amp
		outs aout, aout
endin

///////////////////////////////////////////////////////
///////////////////////////////////////////////////////
//                 Chords                            //
///////////////////////////////////////////////////////
///////////////////////////////////////////////////////

//  //////Chords:SIN from f-table//////
instr 10
  prints "***inst 2***\n";
seed 0;
ifreq random 400, 2000;

amp2 expseg 0.01, p3* 0.08, 0.5, p3 * .92, 0.1 ;overall amp envelope
amp3 expseg 0.01, p3* 0.15, 0.6, p3 * .85, 0.1 ;overall amp envelope

aout oscili 0.2, ifreq, 400
aout2 oscili 0.2, ifreq - 200, 400
aout3 oscili 0.2, ifreq + 860, 400
	outs aout+(aout2*amp2)+(aout3*amp2), aout+(aout2*amp2)+(aout3*amp3)
endin


//  //////Chords:MYCOS w/phase and waveshaping. Uses arate table normalizing //////
instr 11
  prints "***inst 11***\n";
ksig init 0
seed 0;
iphase random 0.01, 0.99
ihertz random 800, 2500;
kcntr init 0
itwopi=3.14

ipkamp = 0.75
iwsfn  = 1000  ;waveshaping function	
inmfn  = 1100  ;normalization function 	
							
reset:
ksig = cos(itwopi*(kcntr + (ginum * iphase))/(ginum/2)) 
tablew ksig, kcntr, 2000, 0, 0, 2  ;write sig moved by phase and added to sin to table
kcntr = kcntr + 1
if kcntr < ginum kgoto reset

agate expseg 0.9, p3* 0.40, 1.0, p3 * .60, 0.1 ;overall amp envelope
agate2 expseg 0.01, p3* 0.10, 0.4, p3 * .90, 0.1 ;overall amp envelope
agate3 expseg 0.01, p3* 0.20, 0.75, p3 * .80, 0.1 ;overall amp envelope

actrl expseg 0.9, p3* 0.20, 1.0, p3 * .80, 0.0001 ;waveshaping index control
aindex  poscil  actrl, ihertz, 2000	;sine wave to be distorted
asignal tablei  .5 + aindex, iwsfn, 1, 1 ;waveshaping (access table values by direct indexing)
anormal tablei  1/actrl, inmfn , 1, 1  ;amplitude normalization

aindex2  poscil  actrl, ihertz + 260, 2000	;sine wave to be distorted
asignal2 tablei  .5 + aindex2, iwsfn, 1, 1 ;waveshaping (access table values by direct indexing)

aindex3  poscil  actrl, ihertz + 800, 2000	;sine wave to be distorted
asignal3 tablei  .5 + aindex3, iwsfn, 1, 1 ;waveshaping (access table values by direct indexing)

outs  asignal*anormal*ipkamp*agate+asignal2*anormal*ipkamp*agate2+asignal3*anormal*ipkamp*agate3, asignal*anormal*ipkamp*agate+asignal2*anormal*ipkamp*agate2+asignal3*anormal*ipkamp*agate3 
             
endin

//   //////Chords:DSP SIN with PHASE//////
instr 12
  prints "***inst 3***\n";
seed 0;
ifreq random 400, 2000;
ksig init 0
kcntr init 0
itwopi=3.14159

reset:
ksin = sin(itwopi*(kcntr + (ginum * .25))/(ginum/2)) 

tablew ksin, kcntr, 500, 0, 0, 2  ;write to table

kcntr = kcntr + 1
if kcntr < ginum kgoto reset

amp2 expseg 0.01, p3* 0.1, 0.5, p3 * .90, 0.1 ;overall amp envelope
amp3 expseg 0.01, p3* 0.17, 0.6, p3 * .83, 0.1 ;overall amp envelope
	
aout oscili 0.2, ifreq, 500
aout2 oscili 0.2, ifreq - 160, 500
aout3 oscili 0.2, ifreq + 480, 500
		outs aout+(aout2*amp2)+(aout3*amp2), aout+(aout2*amp2)+(aout3*amp3)

endin

//  //////Chords:Sawtooth w/phase and waveshaping with spline//////

instr 13
  prints "***inst 12***\n";
krangeMin init 2
krangeMax init 8
kcpsmin init 2
kcpsmax init 4
kval init 0
ksig init 0
seed 0; 
iphase random 0.01, 0.99
ifreq random 900, 2200;
kcntr init 0

reset:
ksp  rspline krangeMin, krangeMax, kcpsmin, kcpsmax  ;generate random spline
;triangle
kval  = (2 * (kcntr/ginum) - (floor((kcntr/ginum) + 0.5))); no phase **** amp is 0 to 1
;kval  = (2 * ((kcntr + (ginum * iphase))/(ginum) - ((floor(((kcntr + (ginum * iphase))/(ginum)) + 0.5))))); amp -1 to 1
ksig = ksp * kval ;modulation
tablew ksig, kcntr, 2000, 0, 0, 2  ;write spline and triangle to table
kcntr = kcntr + 1
if kcntr < ginum kgoto reset

;-----scale amp using array-------------
copyf2array gkArr, 2000
;copy from table to array
scalearray gkArr, -1, 1
copya2ftab gkArr, 1300  ;copy from array to table
tablegpw 1300 ;write the table quardpoint
;---------------------------------------

amp2 expseg 0.01, p3* 0.10, 0.4, p3 * .90, 0.1 ;overall amp envelope
amp3 expseg 0.01, p3* 0.20, 0.75, p3 * .80, 0.1 ;overall amp envelope
	
aout oscili 0.3, ifreq, 1300
aout2 oscili 0.3, ifreq + 360, 1300
aout3 oscili 0.4, ifreq + 780, 1300
		outs aout+(aout2*amp2)+(aout3*amp2), aout+(aout2*amp2)+(aout3*amp3)
		
endin



</CsInstruments>
<CsScore>

; One period of a sine wave
f 400	0 1024	10	1

i1 0  1

e
</CsScore>
</CsoundSynthesizer>
