;jhearon, 2016
;tests the instruments are working without using 
;Csound API and chnget opcode.
;run as usual from the commandline
;ex. ./csound testschedule.csd

<CsoundSynthesizer>
<CsOptions>
csound  -s -d -+rtaudio=ALSA -odevaudio -b1024 -B16384  
;csound  -s -d -+rtaudio=ALSA -o/opt/snd-16/jstest.wav -b1024 -B16384  
</CsOptions>
<CsInstruments>

sr = 44100
;kr = 1
kr = 5
nchnls = 2
0dbfs  = 1

ginum init 1024;
gkArr[] init ginum ;global array for amp scaling

gitable5 ftgen 500, 0, ginum, 8, 0, ginum, 0 ;empty table allocation for piecewise cubic spline curves
gitable6 ftgen 600, 0, ginum, 8, 0, ginum, 0
gitable7 ftgen 700, 0, ginum, 8, 0, ginum, 0
gitable8 ftgen 800, 0, ginum, 8, 0, ginum, 0
gitable9 ftgen 900, 0, ginum, 8, 0, ginum, 0

gitable10 ftgen 1000, 0, ginum, 21, 6  ;for wave shaping and normalizing
gitable11 ftgen 1100, 0, ginum, 4, 1000, 0 ;for wave shaping and normalizing

gitable12 ftgen 1200, 0, ginum, 8, 0, ginum, 0
gitable13 ftgen 1300, 0, ginum, 7, 0, ginum, 0 ;constructs segments from straight lines
gitable14 ftgen 1400, 0, ginum, 7, 0, ginum, 0

gitable20 ftgen 2000, 0, ginum, 7, 0, ginum, 0 ;a main, reusable table 

//   //////SCHEDULE an instrument//////
instr 1
  schedwhen p4, p5, 0, 1
endin


//  //////SIN from f-table//////
instr 2

seed 0;
ifreq random 400, 2000;

aout oscili 0.5, ifreq, 400
	outs aout, aout
endin


//   //////DSP SIN with PHASE//////
instr 3

seed 0;
ifreq random 400, 2000;
ksig init 0
kcntr init 0
itwopi=3.14159

reset:
ksin = sin(itwopi*(kcntr + (ginum * .25))/(ginum/2)) 

tablew ksin, kcntr, 500, 0, 0, 2  ;write to table

kcntr = kcntr + 1
if kcntr < ginum kgoto reset

aout oscili 0.5, ifreq, 500
	outs aout, aout

endin



//   //////RSPLINE MOD by SIN w/phase to table//////
instr 4

krangeMin init 2
krangeMax init 20
kcpsmin init 2
kcpsmax init 3
seed 0;
ifreq random 400, 2000;
iphase random 0.01, 0.99

ksig init 0
kcntr init 0
itwopi=3.14

reset:
ksp  rspline krangeMin, krangeMax, kcpsmin, kcpsmax  ;generate random spline
ksin = sin(itwopi*(kcntr + (ginum * iphase))/(ginum/2)) 
ksig = ksp * ksin  ;simple modulation
tablew ksig, kcntr, 2000, 0, 0, 2  ;write spline modulated by sin to table
kcntr = kcntr + 1
if kcntr < ginum kgoto reset

;-----scale amp using array-------------
copyf2array gkArr, 2000 ;copy from table to array
scalearray gkArr, -1, 1
copya2ftab gkArr, 600  ;copy from array to table
tablegpw 600;write the table quardpoint
;---------------------------------------

aout oscili 0.5, ifreq, 600
	outs aout, aout

endin



//  //////RSPLINE MOD by COS w/phase to table//////
instr 5
krangeMin init 5
krangeMax init 25
kcpsmin init 2
kcpsmax init 5
ksig init 0
seed 0;
iphase random 0.01, 0.99
ifreq random 400, 2000;
kcntr init 0
kval init 0
itwopi=3.14

reset:
ksp  rspline krangeMin, krangeMax, kcpsmin, kcpsmax  ;generate random spline
kval = cos(itwopi*(kcntr + (ginum * iphase))/(ginum/2)) 
ksig = ksp + kval ;modulation
tablew ksig, kcntr, 2000, 0, 0, 2  ;write sig moved by phase and added to sin to table
kcntr = kcntr + 1
if kcntr < ginum kgoto reset
;-----scale amp using array-------------
copyf2array gkArr, 2000 ;copy from table to array
scalearray gkArr, -1, 1
copya2ftab gkArr, 700  ;copy from array to table
tablegpw 700 ;write the table quardpoint
;---------------------------------------
aout oscili 0.5, ifreq, 700
	outs aout, aout
endin


//  //////RSPLINE MOD by COS w/phase to table//////
instr 6
krangeMin init 5
krangeMax init 25
kcpsmin init 1
kcpsmax init 3
ksig init 0
seed 0;
iphase random 0.01, 0.99
ifreq random 400, 3000;
kcntr init 0
kval init 0
itwopi=3.14

reset:
ksp  rspline krangeMin, krangeMax, kcpsmin, kcpsmax  ;generate random spline
kval = cos(itwopi*(kcntr + (ginum * iphase))/(ginum/2)) 
ksig = ksp ^ kval ;modulation
tablew ksig, kcntr, 2000, 0, 0, 2  ;write sig moved by phase and added to sin to table
kcntr = kcntr + 1
if kcntr < ginum kgoto reset
;-----scale amp using array-------------
copyf2array gkArr, 2000 ;copy from table to array
scalearray gkArr, -1, 1
copya2ftab gkArr, 800  ;copy from array to table
tablegpw 800 ;write the table quardpoint
;---------------------------------------
aout oscili 0.5, ifreq, 800
	outs aout, aout
endin


//  //////RSPLINE MOD by SIN w/phase to table including random noise//////
instr 7
krangeMin init 2
krangeMax init 20
kcpsmin init 1
kcpsmax init 3
ksig init 0
seed 0;
iphase random 0.01, 0.99
ifreq random 400, 2000;
kcntr init 0
kval init 0
itwopi=3.14

reset:
ksp  rspline krangeMin, krangeMax, kcpsmin, kcpsmax  ;generate random spline
kval = sin(itwopi*(kcntr + (ginum * iphase))/(ginum/2)) 
krandom random 400, 2000
ksig = (ksp + kval) + (kval + krandom) ;modulation
tablew ksig, kcntr, 2000, 0, 0, 2  ;write sig moved by phase and added to sin to table
kcntr = kcntr + 1
if kcntr < ginum kgoto reset

;-----scale amp using array-------------
copyf2array gkArr, 2000
;copy from table to array
scalearray gkArr, -1, 1
copya2ftab gkArr, 900  ;copy from array to table
tablegpw 900 ;write the table quardpoint
;---------------------------------------

aout oscili 0.5, ifreq, 900
		outs aout, aout
endin


instr   8 ;gaussian distribution and waveshaping. Uses arate table normalizing.

seed 0;
ihertz random 400, 2000;
ipkamp = 0.5
iwsfn  = 1000  ;waveshaping function	
inmfn  = 1100  ;normalization function 	
							
agate   linen   1, .01, p3, .1  ;overall amp envelope
actrl   linen  	.9, 2, p3, 2    ;waveshaping index control
aindex  poscil  actrl, ihertz, 400	;sine wave to be distorted
asignal tablei  .5 + aindex, iwsfn, 1, 1 ;waveshaping (access table values by direct indexing)
anormal tablei  1/actrl, inmfn , 1, 1  ;amplitude normalization
        outs    asignal*anormal*ipkamp*agate, asignal*anormal*ipkamp*agate         
endin



instr   9 ;gaussian distribution and waveshaping w/envelope control.  Uses arate table normalizing.

seed 0;
ihertz random 400, 2000;
ipkamp = 0.75
iwsfn  = 1000  ;waveshaping function	
inmfn  = 1100  ;normalization function 	
							
agate expseg 0.9, p3* 0.10, 1.0, p3 * .90, 0.0001 ;overall amp envelope
actrl   linen  	.2, .5, p3 * .80, 1    ;waveshaping index control
aindex  poscil  actrl * 4, ihertz, 400	;sine wave to be distorted
asignal tablei  .5 + aindex, iwsfn, 1, 1 ;waveshaping (access table values by direct indexing)
anormal tablei  1/actrl, inmfn , 1, 1  ;amplitude normalization
        outs    asignal*anormal*ipkamp*agate, asignal*anormal*ipkamp*agate         
endin


//  //////RSPLINE MOD by SIN w/phase to table including random noise//////
          ;includes final output envelope
instr 10
krangeMin init 2
krangeMax init 20
kcpsmin init 1
kcpsmax init 3
ksig init 0
seed 0;
iphase random 0.01, 0.99
ifreq random 400, 2000;
kcntr init 0
kval init 0
itwopi=3.14

reset:
ksp  rspline krangeMin, krangeMax, kcpsmin, kcpsmax  ;generate random spline
kval = sin(itwopi*(kcntr + (ginum * iphase))/(ginum/2)) 
krandom random 400, 2000
ksig = (ksp + kval) + (kval + krandom) ;modulation
tablew ksig, kcntr, 2000, 0, 0, 2  ;write sig moved by phase and added to sin to table
kcntr = kcntr + 1
if kcntr < ginum kgoto reset

;-----scale amp using array-------------
copyf2array gkArr, 2000
;copy from table to array
scalearray gkArr, -1, 1
copya2ftab gkArr, 1200  ;copy from array to table
tablegpw 1200 ;write the table quardpoint
;---------------------------------------
amp expseg 0.9, p3* 0.08, 1.0, p3 * .92, 0.0001 ;overall amp envelope
aout oscili 0.5, ifreq, 1200
		outs aout * amp, aout * amp
endin


//  //////MYCOS w/phase and waveshaping. Uses arate table normalizing //////
instr 11
ksig init 0
seed 0;
iphase random 0.01, 0.99
ihertz random 400, 2000;
kcntr init 0
itwopi=3.14

ipkamp = 0.75
iwsfn  = 1000  ;waveshaping function	
inmfn  = 1100  ;normalization function 	
							
reset:
ksig = cos(itwopi*(kcntr + (ginum * iphase))/(ginum/2)) 
tablew ksig, kcntr, 2000, 0, 0, 2  ;write sig moved by phase and added to sin to table
kcntr = kcntr + 1
if kcntr < ginum kgoto reset

agate expseg 0.9, p3* 0.40, 1.0, p3 * .60, 0.0001 ;overall amp envelope
actrl expseg 0.9, p3* 0.20, 1.0, p3 * .80, 0.0001 ;waveshaping index control
aindex  poscil  actrl, ihertz, 2000	;sine wave to be distorted
asignal tablei  .5 + aindex, iwsfn, 1, 1 ;waveshaping (access table values by direct indexing)
anormal tablei  1/actrl, inmfn , 1, 1  ;amplitude normalization
        outs    asignal*anormal*ipkamp*agate, asignal*anormal*ipkamp*agate 
endin

///////////////////////////////////////////////////////

//  //////Sawtooth w/phase and waveshaping with spline//////

instr 12
krangeMin init 2
krangeMax init 10
kcpsmin init 2
kcpsmax init 4
kval init 0
ksig init 0
seed 0; 
iphase random 0.01, 0.99
ifreq random 400, 2000;
kcntr init 0

reset:
ksp  rspline krangeMin, krangeMax, kcpsmin, kcpsmax  ;generate random spline
;triangle
kval  = (2 * (kcntr/ginum) - (floor((kcntr/ginum) + 0.5))); no phase **** amp is 0 to 1
;kval  = (2 * ((kcntr + (ginum * iphase))/(ginum) - ((floor(((kcntr + (ginum * iphase))/(ginum)) + 0.5))))); amp -1 to 1
ksig = ksp * kval ;modulation
tablew ksig, kcntr, 2000, 0, 0, 2  ;write spline and triangle to table
kcntr = kcntr + 1
if kcntr < ginum kgoto reset

;-----scale amp using array-------------
copyf2array gkArr, 2000
;copy from table to array
scalearray gkArr, -1, 1
copya2ftab gkArr, 1300  ;copy from array to table
tablegpw 1300 ;write the table quardpoint
;---------------------------------------
aout oscili 0.5, ifreq, 1300
		outs aout, aout
endin


//  //////MYSAWTHOOTH w/phase and waveshaping w/ cos and spline //////

instr 13
krangeMin init 2
krangeMax init 10
kcpsmin init 2
kcpsmax init 4
kval init 0
ksig init 0
kcos init 0
seed 0; 
iphase1 random 0.01, 0.99
iphase2 random 0.01, 0.99
ifreq random 400, 2000;
kcntr init 0
itwopi=3.14

reset:
ksp  rspline krangeMin, krangeMax, kcpsmin, kcpsmax  ;generate random spline
kcos = cos(itwopi*(kcntr + (ginum * iphase1))/(ginum/2)) 
;triangle
;kval  = (2 * (kcntr/ginum) - (floor((kcntr/ginum) + 0.5))); no phase **** amp is 0 to 1
kval  = (2 * ((kcntr + (ginum * iphase2))/(ginum) - ((floor(((kcntr + (ginum * iphase2))/(ginum)) + 0.5))))); amp -1 to 1
ksig = ksp *  (kcos + kval)  ;modulation
tablew ksig, kcntr, 2000, 0, 0, 2  ;write spline and triangle to table
kcntr = kcntr + 1
if kcntr < ginum kgoto reset

;-----scale amp using array-------------
copyf2array gkArr, 2000
;copy from table to array
scalearray gkArr, -1, 1
copya2ftab gkArr, 1400  ;copy from array to table
tablegpw 1400 ;write the table quardpoint
;---------------------------------------
;amp expseg 0.9, p3* 0.08, 1.0, p3 * .92, 0.0001 ;overall amp envelope
aout oscili 0.5, ifreq, 1400
		;outs aout * amp, aout * amp
		outs aout, aout
endin


//    //////WRITE TABLES TO DISK//////
instr 14
 ftsave "/opt/csound6-git/glib_test/ifnx.save", 1, 500
 ftsave "/opt/csound6-git/glib_test/ifnx2.save", 1,600
 ftsave "/opt/csound6-git/glib_test/ifnx3.save", 1,700
 ftsave "/opt/csound6-git/glib_test/ifnx4.save", 1, 800
 ftsave "/opt/csound6-git/glib_test/ifnx5.save", 1, 900
 ftsave "/opt/csound6-git/glib_test/ifnx6.save", 1, 1000
 ftsave "/opt/csound6-git/glib_test/ifnx7.save", 1, 1100
 ftsave "/opt/csound6-git/glib_test/ifnx8.save", 1, 1200
 ftsave "/opt/csound6-git/glib_test/ifnx9.save", 1, 1300
 ftsave "/opt/csound6-git/glib_test/ifnx10.save", 1, 1400
endin




</CsInstruments>
<CsScore>

; One period of a sine wave
f 400	0 1024	10	1


i1  0  14  0  
i1  1  1  1  2
i1  2  .  1  3
i1  3  .  1  4
i1  4  .  1  5
i1  5  .  1  6
i1  6  .  1  7
i1  7  .  1  8
i1  8  .  1  9
i1  9  .  1  10
i1  10  .  1  11
i1  11  .  1  12
i1  12  .  1  13
s
i14  0  2


e
</CsScore>
</CsoundSynthesizer>
